<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */
namespace App\Http\Validators;

use App\Http\Base\Validation;

class ApproverValidator extends Validation
{
    /**
    * this function will call before insert, you can custom as your business requirement
    * @param array $input
    * @return $this
    */
    public function beforeInsert($input){
		if(empty($input["roleId"])){
			array_push($this->error, ["roleId" => "cannot be null"]);
		}
		else{
			$lengthroleid = strlen($input["roleId"]);
			if($lengthroleid>19){
			array_push($this->error, ["roleid" => "value too long"]);
			}
		}
		$roles= (new \App\Http\Models\RolesModel())
			->getQuery()->where("id","=",$input["roleId"])->first();
		if(empty($roles)){
			array_push($this->error, ["roleId" => "invalid relation"]);
		}
		if(empty($input["formIdApprover"])){
			array_push($this->error, ["formIdApprover" => "cannot be null"]);
		}
		else{
			$lengthformidapprover = strlen($input["formIdApprover"]);
			if($lengthformidapprover>3){
			array_push($this->error, ["formidapprover" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before update into database, you can custom as your business requirement
    * @param array $input
    * @param $id
    * @return $this
    */
    public function beforeUpdate($input,$id){
		if(empty($input["roleId"])){
			array_push($this->error, ["roleId" => "cannot be null"]);
		}
		else{
			$lengthroleid = strlen($input["roleId"]);
			if($lengthroleid>19){
			array_push($this->error, ["roleid" => "value too long"]);
			}
		}
		if(!empty($input["roleId"])){
		$roles= (new \App\Http\Models\RolesModel())
			->getQuery()->where("id","=",$input["roleId"])->first();
		if(empty($roles)){
			array_push($this->error, ["roleId" => "invalid relation"]);
		}
		}
		if(empty($input["formIdApprover"])){
			array_push($this->error, ["formIdApprover" => "cannot be null"]);
		}
		else{
			$lengthformidapprover = strlen($input["formIdApprover"]);
			if($lengthformidapprover>3){
			array_push($this->error, ["formidapprover" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before delete from database, you can custom as your business requirement
    * @param $id
    * @return $this
    */
    public function beforeDelete($id){
	return $this;

    }


}